weepingangels = {cfg={}}
weepingangels.ct = {}
weepingangels.tardis = nil
weepingangels.tpos = {}

weepingangels.cfg.advert = true		-- Turn advertisement on or off (I would appreciate it if you kept it on)
weepingangels.cfg.cts = 1			-- Number of Counter-Terrorists
weepingangels.cfg.angelspeed = 10	-- Angel speed when not frozen
weepingangels.cfg.ctspeed = 0		-- CT speed
weepingangels.cfg.arc = 140			-- CT field of view (degrees)
weepingangels.cfg.distance = 350	-- CT field of view length (pixels)
weepingangels.cfg.mode = 1			-- 0 for survival mode, 1 for escape mode
weepingangels.cfg.messages = {		-- Messages shown at the start of the round for each mode and for each team
	[0] = { -- Survival mode
		"\169255255255You are playing Survival mode! You need to kill the survivors before the timer runs out!", -- T
		"\169255255255You are playing Survival mode! You need to survive against the angels until the timer runs out!", -- CT
		["twin"] = "\169255255255The survivors perished!",
		["ctwin"] = "\169255255255The survivors stayed alive!"
	},
	[1] = { -- Escape mode
		"\169255255255You are playing Escape mode! You need to prevent the survivors from getting to the TARDIS!", -- T
		"\169255255255You are playing Escape mode! You need to find the TARDIS before the timer runs out!", -- CT
		["twin"] = "\169255255255The survivors perished!",
		["ctwin"] = "\169255255255The survivors escaped!"
	}
}
weepingangels.cfg.tardis = { -- TARDIS spawn points. If no spawn points are defined for a map, a random point on the map will be selected.
	-- ["de_dust2"] = {{4,7}, {22,2}, {49, 1}} -- Spawn points are defined as a table of XY pairs with the map name as its key
}
weepingangels.cfg.notardis = { -- TARDIS exclusion zones. The TARDIS will *not* spawn in the specified zones or on the specified tile frames.
	["global"] = { -- Global exclusions
		["tiles"] = {0},
		["zones"] = {}
	},
	["de_dust2"] = { -- Map-specific exclusions
		["tiles"] = {0}, -- Excluded tile frames
		["zones"] = {{2,62,2,66}} -- Excluded spawn zones. Each zone is defined as a table of four values that correspond to the top-left and the bottom-right corners of a rectangle.
	},
	
	["de_nuke"] = {
		["zones"] = {{148,14,180,66}}
	}
}

------ UTILITY FUNCTIONS ------

function table.copy(tbl)
	local t = {}
	for k, v in pairs(tbl) do
		t[k] = v
	end
	return t
end

function table.contains(tbl, el)
	for k, v in pairs(tbl) do
		if (v == el) then
			return k
		end
	end
	return false
end

function weepingangels.randomPosition()
	local x, y = math.random(0, map("xsize")), math.random(0, map("ysize"))
	if (weepingangels.cfg.notardis[game("sv_map")]) then
		for _, ex in pairs(weepingangels.cfg.notardis[game("sv_map")].zones) do
			if (x >= ex[1] and x <= ex[3] and y >= ex[2] and y <= ex[4]) then
				return weepingangels.randomPosition()
			end
		end
	end
	if (tile(x, y, "walkable") and not table.contains(weepingangels.cfg.notardis.global.tiles, tile(x, y, "frame")) and (weepingangels.cfg.notardis[game("sv_map")] and weepingangels.cfg.notardis[game("sv_map")].tiles and not table.contains(weepingangels.cfg.notardis[game("sv_map")].tiles, tile(x, y, "frame")) or true)) then
		return x, y
	else
		return weepingangels.randomPosition()
	end
end

------ HOOK DEFINITIONS ------

addhook("endround", "weepingangels.swapTeams")
function weepingangels.swapTeams()
	parse("sv_gamemode 2")
	
	local plys = table.copy(player(0,"table"))
	
	for k, _ in pairs(weepingangels.ct) do table.remove(weepingangels.ct, k) end
	
	for i = 1, weepingangels.cfg.cts do
		local cti = math.random(1, #plys)
		table.insert(weepingangels.ct, plys[cti])
		table.remove(plys, cti)
	end
	
	for _, id in pairs(plys) do
		parse("maket "..id)
	end
	
	for _, id in pairs(weepingangels.ct) do
		parse("makect "..id)
	end
	
	parse("sv_gamemode 0")
end

addhook("startround", "weepingangels.startround")
function weepingangels.startround()
	if weepingangels.cfg.advert then msg("\169255255255This server uses the Weeping Angels mod by EngiN33R.") end
	
	for _, id in pairs(player(0, "team1")) do
		msg2(id, weepingangels.cfg.messages[weepingangels.cfg.mode][1])
		parse("speedmod "..id.." "..weepingangels.cfg.angelspeed)
	end
	for _, id in pairs(player(0, "team2")) do
		msg2(id, weepingangels.cfg.messages[weepingangels.cfg.mode][2])
		parse("speedmod "..id.." "..weepingangels.cfg.ctspeed)
	end
	
	if (weepingangels.cfg.mode == 1) then
		local tx, ty
		if (not weepingangels.cfg.tardis[game("sv_map")] or #weepingangels.cfg.tardis[game("sv_map")] == 0) then
			tx, ty = weepingangels.randomPosition()
		else
			local r = math.random(1, #weepingangels.cfg.tardis[game("sv_map")])
			tx, ty = weepingangels.cfg.tardis[game("sv_map")][r][1], weepingangels.cfg.tardis[game("sv_map")][r][2]
		end
		
		if (weepingangels.tardis) then
			freeimage(weepingangels.tardis)
		end
		weepingangels.tardis = image("gfx/weepingangels/tardis.png", tx*32+16, ty*32+16, 1)
		weepingangels.tpos = {tx, ty}
	end
	
	weepingangels.timer = tonumber(game("mp_roundtime")) * 60
end

function weepingangels._disabler(id)
	return 1
end

addhook("spawn", "weepingangels.spawn")
function weepingangels.spawn(id)
	return "x"
end

addhook("buy", "weepingangels._disabler")
addhook("drop", "weepingangels._disabler")
addhook("hit", "weepingangels.hit")
function weepingangels.hit(id, src)
	if (player(id, "team") == 1) then return 1 end
end

addhook("movetile", "weepingangels.movetile")
function weepingangels.movetile(id, x, y)
	if (weepingangels.cfg.mode == 1 and x == weepingangels.tpos[1] and y == weepingangels.tpos[2] and player(id, "team") == 2 and table.contains(weepingangels.ct, id)) then
		parse("speedmod "..id.." -100")
		table.remove(weepingangels.ct, table.contains(weepingangels.ct, id))
		if (#weepingangels.ct == 0) then
			msg(weepingangels.cfg.messages[1]["ctwin"])
			parse("endround 2")
		end
		parse("makespec "..id)
	end
end

addhook("die", "weepingangels.die")
function weepingangels.die(id)
	if (player(id, "team") == 2 and table.contains(weepingangels.ct, id)) then
		table.remove(weepingangels.ct, table.contains(weepingangels.ct, id))
		if (#weepingangels.ct == 0) then
			msg(weepingangels.cfg.messages[weepingangels.cfg.mode]["twin"])
			parse("endround 1")
		end
	end
end

addhook("parse", "weepingangels.console")
function weepingangels.console(cmd)
	if (cmd:sub(1, 7) == "wa_mode") then
		weepingangels.cfg.mode = tonumber(cmd:sub(9))
		return 2
	end
end

addhook("ms100", "weepingangels.checkFreeze")
function weepingangels.checkFreeze()
	for _, ct in pairs(weepingangels.ct) do
		for _, id in pairs(player(0,"team1living")) do
			if (id ~= ct and player(ct, "health") > 0) then
				local ctx, cty, px, py = player(ct, "x"), player(ct, "y"), player(id, "x"), player(id, "y")
				local ang = math.deg(math.atan2(cty-py, ctx-px) - math.pi/2) % 360
				local rot = player(ct,"rot") % 360
				local d = math.sqrt((ctx-px)^2 + (cty-py)^2)
				if (math.abs(ang-rot) <= weepingangels.cfg.arc/2 and d <= weepingangels.cfg.distance) then
					parse("speedmod "..id.." -100")
				else
					parse("speedmod "..id.." "..weepingangels.cfg.angelspeed)
				end
			end
		end
	end
end

addhook("second", "weepingangels.timerCountdown")
function weepingangels.timerCountdown()
	if (weepingangels.timer) then
		if (weepingangels.timer > 1) then
			weepingangels.timer = weepingangels.timer - 1
		else
			if (tonumber(game("mp_roundtime")) ~= 0) then
				if (weepingangels.cfg.mode == 0) then
					parse("endround 2")
				elseif (weepingangels.cfg.mode == 1) then
					parse("endround 1")
				end
			end
		end
	end
end

if #weepingangels.ct == 0 then parse("restart") end -- Listen server compatibility